﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private UserModel _user;

        public MainWindow()
        {
            _user = new UserModel();
            this.DataContext = _user;

            this.Loaded += MainWindow_Loaded;
            _user.PropertyChanged += User_PropertyChanged;
            InitializeComponent();
        }

        private void User_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
//            this.Title = (sender as UserModel).Age.ToString();
        }

        private void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            System.Diagnostics.Trace.WriteLine("MAIN: " + Thread.CurrentThread.ManagedThreadId);

            Thread t1 = new Thread(worker_DoWork);
            t1.Start();
        }

        private void worker_DoWork()
        {
            System.Diagnostics.Trace.WriteLine("worker_DoWork: " + Thread.CurrentThread.ManagedThreadId);
            while (true)
            { 
                // (this.DataContext as SampleContext).User.Age += 1;
                _user.Age += 1;
                Thread.Sleep(1000);
            }
        }
    }
}
